// Bentigt GLUT!
// Fr Dev-C++ (also Mingw32) siehe http://sites.netscape.net/ptrpck/glut.htm
// mit GLUT linken: Project/Project options/Further object files or linker options:
// -lopengl32 -lglu32 -lglut32

// Korrekturen fr GLUT in Dev-C++:
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE

#include <gl/glut.h>

void renderScene()
{
    glClear(GL_COLOR_BUFFER_BIT);

    glLineWidth(2);

    glEnable(GL_LINE_SMOOTH);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

    glBegin(GL_LINE_LOOP);
        glColor3f(0.0, 1.0, 1.0);
        glVertex3f(-1.0,-1.0,-1.0); // 3f: drei float
        glVertex3f( 1.0,-1.0,-1.0);
        glVertex3f( 1.0, 1.0,-1.0);
        glVertex3f(-1.0, 1.0,-1.0);
    glEnd();

    glBegin(GL_LINE_LOOP);
        glVertex3f(-1.0,-1.0, 1.0);
        glVertex3f( 1.0,-1.0, 1.0);
        glColor3f(1.0, 0.0, 0.0);
        glVertex3f( 1.0, 1.0, 1.0);
        glColor3f(0.0, 1.0, 1.0);
        glVertex3f(-1.0, 1.0, 1.0);
    glEnd();

    glBegin(GL_LINES);
        glColor3f(0.0, 1.0, 1.0);
        glVertex3f(-1.0,-1.0,-1.0);
        glVertex3f(-1.0,-1.0, 1.0);
        glVertex3f(-1.0, 1.0,-1.0);
        glVertex3f(-1.0, 1.0, 1.0);
        glVertex3f( 1.0, 1.0,-1.0);
        glColor3f(1.0, 0.0, 0.0);
        glVertex3f( 1.0, 1.0, 1.0);
        glColor3f(0.0, 1.0, 1.0);
        glVertex3f( 1.0,-1.0,-1.0);
        glVertex3f( 1.0,-1.0, 1.0);
    glEnd();

    glFlush();
}

void changeSize(GLsizei w, GLsizei h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    // senkrechte Projektion auf Bildschirmflche
    // verzerrtes Seitenverhltnis beachten!
    // glOrtho(-2.0, 2.0, -2.0, 2.0, -10.0, 10.0);
    // Parameter: kleinster und grter x-Wert, kleinster und grter y-Wert, kleinste und grte Entfernung

    // senkrechte Projektion auf Bildschirmflche mit richtigem Seitenverhltnis
    // eine von vielen mglichen Lsungen
    // glOrtho(-2.0*w/500.0, 2.0*w/500.0, -2.0*h/500.0, 2.0*h/500.0, -10.0, 10.0);

    gluPerspective(45.0, w/(double)h, 2.0, 10.0); // h==0: nicht abgefangener Fehler!!!
    // Parameter: vertikaler Sichtbereich in Grad, Seitenverhltnis, kleinste und grte Entfernung
}

void specialFunc(int key, int x, int y)
{
    glMatrixMode(GL_MODELVIEW);
    // Drehung msste aufwendiger programmiert werden; so noch nicht intuitiv
    switch(key)
    {
    case GLUT_KEY_RIGHT:
        glRotatef(2.0, 0.0, 1.0, 0.0);
        break;
    case GLUT_KEY_LEFT:
        glRotatef(-2.0, 0.0, 1.0, 0.0);
        break;
    case GLUT_KEY_UP:
        glRotatef(-2.0, 1.0, 0.0, 0.0);
        break;
    case GLUT_KEY_DOWN:
        glRotatef(2.0, 1.0, 0.0, 0.0);
        break;
    default:
        ;
    }

    glutPostRedisplay();
}

int main(int argc, char* argv[])
{
    glutInit(&argc, argv);

    glutInitWindowSize(500, 600);
    glutInitWindowPosition(34, 45);

    // berflssig, da Standard: glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
    glutCreateWindow("GL-Perspektive");

    glutDisplayFunc(renderScene);
    glutReshapeFunc(changeSize);
    glutSpecialFunc(specialFunc);

    glMatrixMode(GL_MODELVIEW);
    glTranslatef(0.0, 0.0, -5.0);

    glutMainLoop();

    return 0; // wird nie erreicht
}
